<template>
  <dropdown :isBtnActive="!!filter.activeItems.length" class="check-dropdown">

    <template v-slot:btn>

      <template v-if="!filter.activeItems.length">
        {{ filter.name }}
        <icon-small-arrow class="dropdown__icon"/>
      </template>

      <template v-else>
        <span class="dropdown__text">
          {{ filter.activeItems.length === 1
              ? filter.activeItems[0].name
              : `${ filter.shortName }: ${filter.activeItems.length} знач.` }}
        </span>

        <span @click="clearValue" class="dropdown__icon-wrapper">
          <icon-cross class="dropdown__icon"/>
        </span>
      </template>

    </template>

    <template v-slot:body>

      <filter-input placeholder="Поиск"
                    v-model="search"
                    class="check-dropdown__input"
      />

      <perfect-scrollbar v-if="!needToResetScroll" class="check-dropdown__wrapper" ref="ps">
        <checkbox v-for="item in filtredSearchCkecks" :key="item.id"
                  name="dropdownCheckboxes" :val="item"
                  v-model="checkedItems"
                  class="check-dropdown__checkbox">
          {{ item.name }}
        </checkbox>
      </perfect-scrollbar>

      <button type="button"
              class="button button--green check-dropdown__btn"
              @click="setActiveItems">
        Применить
      </button>

    </template>

  </dropdown>
</template>

<script>
  import { PerfectScrollbar } from 'vue2-perfect-scrollbar';
  import 'vue2-perfect-scrollbar/dist/vue2-perfect-scrollbar.css';

  import Dropdown from './Dropdown';
  import IconSmallArrow from '../icons/IconSmallArrow';
  import IconCross from '../icons/IconCross';
  import Checkbox from '../Checkbox';
  import FilterInput from '../FilterInput';
  import closeDropdowns from '../../assets/js/helpers/close-dropdowns';

  export default {
    name: 'CheckDropdown',
    props: {
      filter: {
        type: Object,
        required: true
      }
    },
    components: {
      PerfectScrollbar,
      FilterInput,
      Checkbox,
      IconCross,
      IconSmallArrow,
      Dropdown,
    },
    data: () => ({
      search: '',
      checkedItems: [],
      needToResetScroll: false
    }),
    mounted() {
      this.checkedItems = [...this.filter.activeItems]
    },
    watch: {
      filter: {
        deep: true,

        handler() {
          if (!this.filter.activeItems.length) {
            this.checkedItems = [];
          }
        }
      },

      filtredSearchCkecks() {
          this.resetScroll()
      }
    },
    computed: {
      filtredSearchCkecks() {
        return this.filter.values.filter((item) =>
          item.name.toLowerCase().includes(this.search.toLowerCase())
        );
      }
    },
    methods: {
      clearValue(event) {
        event.stopPropagation();

        this.resetScroll()

        this.checkedItems = [];
        this.$emit('clearValue');
        closeDropdowns();
      },

      setActiveItems() {
        this.$emit('setActiveItems', [...this.checkedItems]);
        closeDropdowns();
      },

      resetScroll() {
        this.needToResetScroll = true;

        this.$nextTick(() => {
          this.needToResetScroll = false;
        });
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .check-dropdown {

    &__checkbox {
      &:not(:first-of-type) {
        margin-top: rem(22);
      }
    }

    &__input {
      width: 100%;
      margin-bottom: rem(24);

      border-radius: rem(8);
    }

    &__btn {
      width: 100%;
      margin-top: rem(30);
    }

    &__wrapper {
      max-height: rem(208);
    }

    .dropdown__body {
      &::after {
        content: '';

        position: absolute;
        left: 0;
        bottom: rem(92);

        height: rem(64);
        width: 100%;

        background: linear-gradient(180deg, rgba(245, 248, 251, 0) 0%, #F5F8FB 81.77%, #F5F8FB 100%);
        pointer-events: none;
      }
    }
  }
</style>
